; ##############################################################################
; ##############################################################################
; ##############################################################################
; INITIALISIERUNG																
;																				
ONE_WIRE_INITIALISIERUNG:
	; PORT + PIN definieren				
	cbi (OW_DDR), (OW_PORTBIT)	; AUF EINGANG	
	cbi (OW_PORT),(OW_PORTBIT)	; PULL-UP aus	
	; 1-WIRE-LEDs definieren			
	sbi (OW_LED_DDR),(LED_OW_GRUEN)
	sbi (OW_LED_DDR),(LED_OW_GELB)
	sbi (OW_LED_DDR),(LED_OW_ROT)
	sbi (OW_LED_DDR),(LED_OW_TRIGGER)
	rcall wait_100ms
	; LEDs aus							
	sbi (OW_LED_PORT),LED_OW_GRUEN		; GRN	
	sbi (OW_LED_PORT),LED_OW_GELB		; GELB 	
	sbi (OW_LED_PORT),LED_OW_ROT		; ROT	
	; 1-wire-STATUS	sperren !			
	rcall STATUS_SPERREN_SETZEN	;  STATUS: gesperrt		
	;  1-WIRE-ROM-ID					
	ldi temp1,ROM_ID_BYTE1
	ldi temp2,ROM_ID_BYTE2
	ldi temp3,ROM_ID_BYTE3
	ldi temp4,ROM_ID_BYTE4
	ldi temp5,ROM_ID_BYTE5
	ldi temp6,ROM_ID_BYTE6
	ldi temp7,ROM_ID_BYTE7
	ldi temp8,ROM_ID_BYTE8
	STS(adr_OW_ROM_ID_BEREICH8+0),temp1
	STS(adr_OW_ROM_ID_BEREICH8+1),temp2
	STS(adr_OW_ROM_ID_BEREICH8+2),temp3
	STS(adr_OW_ROM_ID_BEREICH8+3),temp4
	STS(adr_OW_ROM_ID_BEREICH8+4),temp5
	STS(adr_OW_ROM_ID_BEREICH8+5),temp6
	STS(adr_OW_ROM_ID_BEREICH8+6),temp7
	STS(adr_OW_ROM_ID_BEREICH8+7),temp8
	; 1-WIRE-LED-TEST				
	cbi (OW_LED_PORT),LED_OW_GRUEN	; GRN	
	cbi (OW_LED_PORT),LED_OW_GELB	; GELB 	
	cbi (OW_LED_PORT),LED_OW_ROT	; ROT	
	rcall wait_1s
	sbi (OW_LED_PORT),LED_OW_GRUEN	; GRN	
	sbi (OW_LED_PORT),LED_OW_GELB	; GELB 	
	sbi (OW_LED_PORT),LED_OW_ROT	; ROT	
	; 1-WIRE CRC Check				
	rcall ONE_WIRE_ROM_CRC7
	; 1-WIRE ANZEIGE_ROM_ID			
	rcall ANZEIGE_ROM_ID
; ------------------------------------------------------------------------------
	; SCRATCHPAD-A(BEISPIEL DS18s20) 0x00100CFFFF464B002E	
	ldi temp8,0x00
	ldi temp7,0x10
	ldi temp6,0x0C
	ldi temp5,0xFF
	ldi temp4,0xFF
	ldi temp3,0x46
	ldi temp2,0x4B
	ldi temp1,0x00
	ldi temp ,0x2E
	STS(adr_OW_SCRATCHPAD_A_BEREICH+8),temp8
	STS(adr_OW_SCRATCHPAD_A_BEREICH+7),temp7
	STS(adr_OW_SCRATCHPAD_A_BEREICH+6),temp6
	STS(adr_OW_SCRATCHPAD_A_BEREICH+5),temp5
	STS(adr_OW_SCRATCHPAD_A_BEREICH+4),temp4
	STS(adr_OW_SCRATCHPAD_A_BEREICH+3),temp3
	STS(adr_OW_SCRATCHPAD_A_BEREICH+2),temp2
	STS(adr_OW_SCRATCHPAD_A_BEREICH+1),temp1
	STS(adr_OW_SCRATCHPAD_A_BEREICH+0),temp
	; SCRATCHPAD-B
	STS(adr_OW_SCRATCHPAD_B_BEREICH+8),NULL
	STS(adr_OW_SCRATCHPAD_B_BEREICH+7),NULL
	STS(adr_OW_SCRATCHPAD_B_BEREICH+6),NULL
	STS(adr_OW_SCRATCHPAD_B_BEREICH+5),NULL
	STS(adr_OW_SCRATCHPAD_B_BEREICH+4),NULL
	STS(adr_OW_SCRATCHPAD_B_BEREICH+3),NULL
	STS(adr_OW_SCRATCHPAD_B_BEREICH+2),NULL
	STS(adr_OW_SCRATCHPAD_B_BEREICH+1),NULL
	STS(adr_OW_SCRATCHPAD_B_BEREICH+0),NULL
	; SCRATCHPAD-C
	STS(adr_OW_SCRATCHPAD_C_BEREICH+8),NULL
	STS(adr_OW_SCRATCHPAD_C_BEREICH+7),NULL
	STS(adr_OW_SCRATCHPAD_C_BEREICH+6),NULL
	STS(adr_OW_SCRATCHPAD_C_BEREICH+5),NULL
	STS(adr_OW_SCRATCHPAD_C_BEREICH+4),NULL
	STS(adr_OW_SCRATCHPAD_C_BEREICH+3),NULL
	STS(adr_OW_SCRATCHPAD_C_BEREICH+2),NULL
	STS(adr_OW_SCRATCHPAD_C_BEREICH+1),NULL
	STS(adr_OW_SCRATCHPAD_C_BEREICH+0),NULL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXTERNER_INTERUPT_INITIALISIEREN:
;																			
; SLEEP+INT0+INT1 (externer Interrupt) konfigurieren						
;																			
; MCUCR => SE SM2 SM1 SM0 ISC11 ISC10 ISC01 ISC00 							
; SM2 SM1 SM0 Sleep Mode													
; 0   0   0   Idle															
; 0   0   1   ADC Noise Reduction											
; 0   1   0   Power-down													
; 0   1   1   Power-save													
; 1   0   0   Reserved														
; 1   0   1   Reserved														
; 1   1   0   Standby(1)													
;																			
;ISC11 ISC10 Description													
; 0 	0 	The low level of INT1 generates an interrupt request.			
; 0 	1 	Any logical change on INT1 generates an interrupt request.		
; 1 	0 	The falling edge of INT1 generates an interrupt request.		
; 1 	1 	The rising edge of INT1 generates an interrupt request.			
;																			
;ISC01 ISC00 Description													
; 0 	0 	The low level of INT0 generates an interrupt request.			
; 0 	1 	Any logical change on INT0 generates an interrupt request.		
;*1 	0 	The falling edge of INT0 generates an interrupt request.		
; 1 	1 	The rising  edge of INT0 generates an interrupt request.		
;																			
	ldi temp,(0<<SE)|(0<<SM2)|(0<<SM1)|(0<<SM0)|(0<<ISC11)|(0<<ISC10)|(1<<ISC01)|(0<<ISC00) 
	out MCUCR,temp
ret
; ##############################################################################
EXTERNER_INTERRUPT_AKTIVIEREN:
;																			
; INT0+INT1 (externer Interrupt)aktivieren									
;																			
; GICR => INT1 INT0 - - - - IVSEL IVCE 										
; General Interrupt Control													
;																			
	ldi temp, (0<<INT1)|(1<<INT0)|(0<<IVSEL)|(0<<IVCE)   
    out GICR, temp 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; sehr zeitkritisch ist das Schreiben eines 0-SLOT !							
;																				
; INP/OUT: OW_STATUS															
INTERRUPT:
	; REGISTER sichern			
	push temp								;
	in temp,SREG							; SREG 
	push temp	    						; 
	push temp1								; 
	push ZL									; 
	push ZH									; 
	; STATUS laden und abfragen
	LDS temp,(adr_OW_STATUS)
	; 0-SLOT senden?			
	cpi temp,OW_STATUS_TX_0SLOT
	breq INTERRUPT_MODUS_WRITE_0SLOT
	; 1-SLOT senden?			
	cpi temp,OW_STATUS_TX_1SLOT
	breq INTERRUPT_MODUS_WRITE_1SLOT
	; gesperrt ?				
	cpi temp,OW_STATUS_GESPERRT
	breq INTERRUPT_RESET_PRESENCE_CHECK
	;READ-MODUS					
	rjmp INTERRUPT_MODUS_READ
; ##############################################################################
; ##############################################################################
; ##############################################################################
INTERRUPT_MODUS_WRITE_0SLOT:
	sbi (OW_DDR)     , (OW_PORTBIT)	; AUF AUSGANG	
	cbi (OW_LED_PORT),LED_OW_GELB	; GELB 			
	; PAUSE ca.25s (0-SLOT) MASTER SAMPLES nach ca 9s		
	rcall wait_5us
	rcall wait_5us
	rcall wait_5us
	rcall wait_5us
	rcall wait_5us
	cbi (OW_DDR), (OW_PORTBIT)		; AUF EINGANG	
	STS(adr_OW_STATUS),NULL			; STATUS-BEREIT	
rjmp INTERRUPT_AUSWERTUNG
; ------------------------------------------------------------------------------
INTERRUPT_MODUS_WRITE_1SLOT:
	cbi (OW_DDR), (OW_PORTBIT)		; AUF EINGANG	
	cbi (OW_LED_PORT),LED_OW_GELB	; GELB 			
	STS(adr_OW_STATUS),NULL			; STATUS-BEREIT	
rjmp INTERRUPT_AUSWERTUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
INTERRUPT_MODUS_READ:
	cbi (OW_LED_PORT),LED_OW_GRUEN				; GRN							
	; ca. 10s PAUSE				
	rcall wait_5us
	rcall wait_5us
	; SAMPLES (PIN abfragen)		
	sbic (OW_PIN),(OW_PORTBIT)	; springe, wenn BIT(PIN) low	
	rjmp INTERRUPT_MODUS_READ_1SLOT
; ------------------------------------------------------------------------------
INTERRUPT_MODUS_READ_0SLOT:
	; STATUS						
	ldi temp,(OW_STATUS_RX_0SLOT)
	STS(adr_OW_STATUS),temp					; STATUS						
	rjmp INTERRUPT_AUSWERTUNG
; ------------------------------------------------------------------------------
INTERRUPT_MODUS_READ_1SLOT:
	cbi (OW_LED_PORT),LED_OW_TRIGGER				; TRIGGER   (Wartungszwecke)	
	; STATUS 						
	ldi temp,(OW_STATUS_RX_1SLOT)
	STS(adr_OW_STATUS),temp					; STATUS						
	rjmp INTERRUPT_AUSWERTUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
; AUSWERTUNG und Berechnung der ROM und Functions Commands						
INTERRUPT_AUSWERTUNG:
	rcall FUNCTION_COMMAND_AUSWERTUNG
	rcall ROM_COMMAND_AUSWERTUNG
; ##############################################################################
; ##############################################################################
; ##############################################################################
INTERRUPT_RESET_PRESENCE_CHECK:
	clr ZL
	clr ZH
INTERRUPT_RESET_PRESENCE_CHECK_s:
	; PIN abfragen			
	sbic (OW_PIN),(OW_PORTBIT)	; springe, wenn BIT(PIN) low
	rjmp INTERRUPT_RESET_PRESENCE_CHECK_AUSWERTUNG
	; ZHLER				
	adiw ZL,1
	brcc INTERRUPT_RESET_PRESENCE_CHECK_s
	; BERLAUF				
	;WDR
	ldi ZL,255
	ldi ZH,255
	cbi (OW_LED_PORT),LED_OW_GRUEN					; GRN							
	cbi (OW_LED_PORT),LED_OW_GELB						; GELB 							
	cbi (OW_LED_PORT),LED_OW_ROT						; ROT							
	; 1-wire-STATUS	sperren !	
	rcall STATUS_SPERREN_SETZEN	;  STATUS: gesperrt	
	rjmp INTERRUPT_RESET_PRESENCE_CHECK_s
	; AUSWERTUNG			
INTERRUPT_RESET_PRESENCE_CHECK_AUSWERTUNG:
	; vergleich (HIGH)		
	cpi ZH,255
	breq INTERRUPT_FERTIG
	; vergleich (HIGH)		
	tst ZH
	breq INTERRUPT_FERTIG
	; ZHLER				
	STS(adr_OW_ZAEHLER_RESET_PRESENCE_L),ZL	; speichern (Wartungszwecke)
	STS(adr_OW_ZAEHLER_RESET_PRESENCE_H),ZH
rjmp INTERRUPT_RESET_PRESENCE_IMPULS	
; ##############################################################################
; ##############################################################################
; ##############################################################################
; RESET and PRESENCE															
INTERRUPT_RESET_PRESENCE_IMPULS:
	; Pause				
	rcall wait_50us
	; Pause				
	sbi (OW_DDR), (OW_PORTBIT)	; AUF AUSGANG	
	rcall wait_50us
	rcall wait_50us
	rcall wait_50us
	cbi (OW_DDR), (OW_PORTBIT)	; AUF EINGANG	
	; CLEAR				
	STS(adr_OW_STATUS),NULL					; STATUS						
	STS(adr_OW_ZEIGER),NULL
	STS(adr_OW_RX_BYTE),NULL	
	STS(adr_OW_BIT_ZAEHLER),NULL
	STS(adr_OW_RX_ROM_COMMAND),NULL
	STS(adr_OW_RX_ROM_COMMAND_FERTIG),NULL
	STS(adr_OW_RX_FUNCTION_COMMAND),NULL
	STS(adr_OW_RX_FUNCTION_COMMAND_FERTIG),NULL

rjmp INTERRUPT_FERTIG
; ##############################################################################
; ##############################################################################
; ##############################################################################
INTERRUPT_FERTIG:
	; REGISTER wieder herstellen				
	pop ZH									; 
	pop ZL									; 
	pop temp1								; 
	pop	temp								; 
	OUT SREG, temp							; SREG	
	pop temp								;
; ------------------------------------------------------------------------------
	sbi (OW_LED_PORT),LED_OW_GRUEN				; GRN							
	sbi (OW_LED_PORT),LED_OW_GELB					; GELB 							
	sbi (OW_LED_PORT),LED_OW_ROT					; ROT							
	sbi (OW_LED_PORT),LED_OW_TRIGGER				; TRIGGER   (Wartungszwecke)	
	out GIFR,VOLL							; eventuelle Pegelwechsel ignorieren
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
; CRC Berechnung bernommen und abgendert von: http://s-huehn.de				
; CRC-Berechnung Application Note 27 von Dallas/Maxim							
;																				
; CRC-ROM																		
; INP: SRAM																		
;																				
ONE_WIRE_ROM_CRC7:
	push XL          ; auf dem Stack sichern            
	push XH
	push r16
	push r17
	push r18
	push r19
	push r20
	push r21
ONE_WIRE_ROM_CRC7_RUN:
	; INITIALISIERUNG
 	ldi XL,low (adr_OW_ROM_ID_BEREICH8+0) ;Zeiger 				
    ldi XH,high(adr_OW_ROM_ID_BEREICH8+0) 
    ldi     r19, 7                          ;7 Bytes berechnen			
    ldi     r20, 0x18                       ;Konstante fr Berechnung
    clr     r17                            ;CRC-Startwert = 0 setzen
ONE_WIRE_CRC7_100: 
	ld      r18, x+                         ;Byte aus Puffer holen
    mov     r21, r18                        ;Byte zwischenspeichern
    ldi     r16, 8                          ;8 Verschiebungen
ONE_WIRE_CRC7_200: 
	eor     r18, r17                      	;CRC berechnen
    ror     r18                             ;Ergebnis in Carry schieben
    mov     r18, r17                      	;letzten CRC-Wert holen
    brcc    ONE_WIRE_CRC7_300                          ;war Ergebnis = 0? ja -> weiter
    eor     r18, r20                        ;sonst CRC-Wert updaten
ONE_WIRE_CRC7_300: 
	ror     r18                             ;neuen CRC-Wert positionieren
    mov     r17, r18          	            ;und speichern
    mov     r18, r21                        ;restliche Bits holen
    bst     r18, 0                          ;LSB sichern, nchste Bitposition
    ror     r18                             ;gesichertes Bit als MSB einsetzen
    bld     r18, 7                          ;(Ersatz fr RR-Befehl)
    mov     r21, r18                        ;und Wert zwischenspeichern
    dec     r16                             ;alle Verschiebungen erledigt?
    brne    ONE_WIRE_CRC7_200               ;nein -> Schleife
    dec     r19                             ;alle Bytes bearbeitet?
    brne    ONE_WIRE_CRC7_100               ;nein -> Schleife
;-------------------------------------------------------------------------------
	LDS temp,(adr_OW_ROM_ID_BEREICH8+7)
	; ev. Korrektur
	STS(adr_OW_ROM_ID_BEREICH8+7),R17
	cp temp,r17
	brne ONE_WIRE_CRC7_ERROR
	SEC										; CARRY=1	
	rjmp ONE_WIRE_CRC7_FERTIG
;-------------------------------------------------------------------------------
ONE_WIRE_CRC7_ERROR:
	cbi (OW_LED_PORT),LED_OW_ROT	; ROT	
	; ERROR 
	rcall LCD_CLEAR
	ldi temp,'C'
	rcall LCD_DATA
	ldi temp,'R'
	rcall LCD_DATA
	ldi temp,'C'
	rcall LCD_DATA
	rcall LCD_SPACE

	rcall wait_1s

	ldi temp,'E'
	rcall LCD_DATA
	ldi temp,'R'
	rcall LCD_DATA
	ldi temp,'R'
	rcall LCD_DATA
	ldi temp,'R'
	rcall LCD_DATA
	ldi temp,'O'
	rcall LCD_DATA
	ldi temp,'R'
	rcall LCD_DATA
	rcall LCD_SPACE

	rcall wait_1s

	ldi temp,'O'
	rcall LCD_DATA
	ldi temp,'K'
	rcall LCD_DATA

	rcall wait_1s
	sbi (OW_LED_PORT),LED_OW_ROT	; ROT	
	; nochmal prfen !			
	rjmp ONE_WIRE_ROM_CRC7_RUN
;-------------------------------------------------------------------------------
ONE_WIRE_CRC7_FERTIG:
	pop r21      							; wiederherstellen                	
	pop r20
	pop r19
	pop r18
	pop r17
	pop r16
	pop XH
	pop XL
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 	rcall STATUS_ABFRAGE_UMWANDLUNG_OUT_TEMP ; OUT: 0=0SLOT 1=1SLOT				
STATUS_ABFRAGE_UMWANDLUNG_OUT_TEMP:
	; STATUS laden und abfragen
	LDS temp,(adr_OW_STATUS)	
	cpi temp,(OW_STATUS_RX_1SLOT)
	breq STATUS_ABFRAGE_UMWANDLUNG_OUT_TEMP_1
STATUS_ABFRAGE_UMWANDLUNG_OUT_TEMP_0:
	clr temp
	ret
STATUS_ABFRAGE_UMWANDLUNG_OUT_TEMP_1:
	ldi temp,1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 	rjmp STATUS_SPERREN_SETZEN	;  STATUS: gesperrt								
STATUS_SPERREN_SETZEN:
	; SPERREN						
	ldi temp,(OW_STATUS_GESPERRT)
	STS(adr_OW_STATUS),temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;	rcall STATUS_TX_0SLOT_SETZEN ; STATUS: TX-0SLOT								
STATUS_TX_0SLOT_SETZEN:
	; STATUS		
	ldi temp,(OW_STATUS_TX_0SLOT)
	STS(adr_OW_STATUS),temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
;	rcall STATUS_TX_1SLOT_SETZEN ; STATUS: TX-1SLOT								
STATUS_TX_1SLOT_SETZEN:
	; STATUS		
	ldi temp,(OW_STATUS_TX_1SLOT)
	STS(adr_OW_STATUS),temp	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################

