; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_COMMAND_AUSWERTUNG:
	; ROM Command schon komplett abgearbeitet?		
	LDS temp,(adr_OW_RX_ROM_COMMAND_FERTIG)
	tst temp
	brne FUNCTION_COMMAND_AUSWERTUNG_w
	ret
FUNCTION_COMMAND_AUSWERTUNG_w:
	; Function Command schon komplett abgearbeitet?
	LDS temp,(adr_OW_RX_FUNCTION_COMMAND_FERTIG)
	tst temp
	breq FUNCTION_COMMAND_AUSWERTUNG_RUN
	ret
FUNCTION_COMMAND_AUSWERTUNG_RUN:
	rcall FUNCTION_READ_SCRATCHPAD_A
	rcall FUNCTION_READ_SCRATCHPAD_B
	rcall FUNCTION_READ_SCRATCHPAD_C
	rcall FUNCTION_WRITE_SCRATCHPAD_A
	rcall FUNCTION_WRITE_SCRATCHPAD_B
	rcall FUNCTION_WRITE_SCRATCHPAD_C
	rcall FUNCTION_COMMAND_RX
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_COMMAND_RX:
	; FUNCTION Command schon erkannt / noch NULL ?
	LDS temp,(adr_OW_RX_FUNCTION_COMMAND)
	tst temp
	breq FUNCTION_COMMAND_RX_RUN
	ret
; ------------------------------------------------------------------------------
FUNCTION_COMMAND_RX_RUN:
	; 0/1 SLOT ?				
	rcall STATUS_ABFRAGE_UMWANDLUNG_OUT_TEMP ; OUT: 0=0SLOT 1=1SLOT
	tst temp
	brne FUNCTION_COMMAND_RX_1SLOT	; RX 1-SLOT						
; ------------------------------------------------------------------------------
; 0-SLOT wurde empfangen														
FUNCTION_COMMAND_RX_0SLOT:			; RX 0-SLOT						
	LDS temp,(adr_OW_RX_BYTE)		; "BITs" laden					
	LSR temp						; 1xrechts ohne CARRY			
	STS(adr_OW_RX_BYTE),temp		; "BITs" speichern				
	rjmp FUNCTION_COMMAND_RX_SLOT
; ------------------------------------------------------------------------------
; 1-SLOT wurde empfangen														
FUNCTION_COMMAND_RX_1SLOT:			; RX 1-SLOT						
	LDS temp,(adr_OW_RX_BYTE)		; "BITs" laden					
	SEC								; C=1							
	ROR temp						; 1xrechts ber Carry 			
	STS(adr_OW_RX_BYTE),temp		; "BITs" speichern				
; ------------------------------------------------------------------------------
; SLOT auswerten																
FUNCTION_COMMAND_RX_SLOT:	
	LDS temp,(adr_OW_BIT_ZAEHLER)	; ZEIGER "BITs" laden		
	inc temp
	STS(adr_OW_BIT_ZAEHLER),temp	; ZEIGER "BITs" speichern	
	cpi temp,8						; vergleich					
	breq FUNCTION_COMMAND_RX_SLOT_BYTE
	ret
; ------------------------------------------------------------------------------
; BYTE auswerten																
FUNCTION_COMMAND_RX_SLOT_BYTE:
	; "BITs" laden					
	LDS temp,(adr_OW_RX_BYTE)	
	; ROM-COMMAND speichern SRAM	
	STS(adr_OW_RX_FUNCTION_COMMAND),temp
	; NULL							
	STS(adr_OW_BIT_ZAEHLER),NULL		; BIT-ZEIGER NULL		
	STS(adr_OW_RX_BYTE),NULL			; "BITs" NULL			
	STS(adr_OW_ZEIGER),NULL				; ZEIGER				
	STS(adr_OW_ROM_SEARCH_ZAEHLER),NULL	; SEARCH-ZAEHLER		
	STS(adr_OW_STATUS),NULL				; STATUS				
; ------------------------------------------------------------------------------
	; AUSWERTUNG					
	cpi temp,(OW_FUNCTION_READ_SCRATCHPAD_A)	; READ SCRATCHPAD-A			
	breq FUNCTION_COMMAND_RX_READ_SCRATCHPAD_A
	cpi temp,(OW_FUNCTION_READ_SCRATCHPAD_B)	; READ SCRATCHPAD-B			
	breq FUNCTION_COMMAND_RX_READ_SCRATCHPAD_B
	cpi temp,(OW_FUNCTION_READ_SCRATCHPAD_C)	; READ SCRATCHPAD-C			
	breq FUNCTION_COMMAND_RX_READ_SCRATCHPAD_C

	cpi temp,(OW_FUNCTION_WRITE_SCRATCHPAD_A)	; WRITE	SCRATCHPAD-A		
	breq FUNCTION_COMMAND_DUMMY
	cpi temp,(OW_FUNCTION_WRITE_SCRATCHPAD_B)	; WRITE	SCRATCHPAD-B		
	breq FUNCTION_COMMAND_DUMMY
	cpi temp,(OW_FUNCTION_WRITE_SCRATCHPAD_C)	; WRITE	SCRATCHPAD-C		
	breq FUNCTION_COMMAND_DUMMY

	cpi temp,(OW_FUNCTION_SONDER_A)				; SONDERFUNKTION A			
	breq FUNCTION_COMMAND_RX_SONDER_A
	cpi temp,(OW_FUNCTION_SONDER_B)				; SONDERFUNKTION B			
	breq FUNCTION_COMMAND_RX_SONDER_B
	cpi temp,(OW_FUNCTION_SONDER_C)				; SONDERFUNKTION C			
	breq FUNCTION_COMMAND_RX_SONDER_C

	; ERROR	!!!						
	mov temp1,temp
	ldi temp,(ERROR_FUNCTION_COMAND)
	rcall ERROR_SPEICHERN					; INP: temp+temp1
	; unbekanntes FUNCTIONS COMMAND ==> SPERREN
	rjmp STATUS_SPERREN_SETZEN		;  STATUS: gesperrt	
; ------------------------------------------------------------------------------
FUNCTION_COMMAND_DUMMY:
	; NIX tun						
	ret
; ------------------------------------------------------------------------------
FUNCTION_COMMAND_RX_READ_SCRATCHPAD_A:
	rjmp FUNCTION_READ_SCRATCHPAD_A
FUNCTION_COMMAND_RX_READ_SCRATCHPAD_B:
	rjmp FUNCTION_READ_SCRATCHPAD_B
FUNCTION_COMMAND_RX_READ_SCRATCHPAD_C:
	rjmp FUNCTION_READ_SCRATCHPAD_C
; ------------------------------------------------------------------------------
FUNCTION_COMMAND_RX_SONDER_A:
	ret
FUNCTION_COMMAND_RX_SONDER_B:
	ret
FUNCTION_COMMAND_RX_SONDER_C:
	ret

; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_READ_SCRATCHPAD_A:
	; SCRATCHPAD READ ?	
	LDS temp,(adr_OW_RX_FUNCTION_COMMAND)	
	cpi temp,(OW_FUNCTION_READ_SCRATCHPAD_A)
	breq FUNCTION_READ_SCRATCHPAD_A_RUN
	ret
; ------------------------------------------------------------------------------
FUNCTION_READ_SCRATCHPAD_A_RUN:
	; Z-ZEIGER			
	ldi ZL, LOW(adr_OW_SCRATCHPAD_A_BEREICH+0)
	ldi ZH,HIGH(adr_OW_SCRATCHPAD_A_BEREICH+0)
	; BIT-Zhler		
	LDS temp,(adr_OW_BIT_ZAEHLER)
	; BIT auslesen		
	rcall FUNKTION_SRAM_BIT_READ_Z_TEMP			; inp: temp+Z OUT: temp+Carry	
	; AUSWERTUNG		
	BRCS FUNCTION_READ_SCRATCHPAD_A_WRITE_1SLOT	; CARRY=1 ==> SPRUNG			
; ------------------------------------------------------------------------------
FUNCTION_READ_SCRATCHPAD_A_WRITE_0SLOT:
	rcall STATUS_TX_0SLOT_SETZEN ; STATUS: TX-0SLOT	
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
FUNCTION_READ_SCRATCHPAD_A_WRITE_1SLOT:
	rcall STATUS_TX_1SLOT_SETZEN ; STATUS: TX-0SLOT	
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_READ_SCRATCHPAD_B:
	; SCRATCHPAD READ ?	
	LDS temp,(adr_OW_RX_FUNCTION_COMMAND)	
	cpi temp,(OW_FUNCTION_READ_SCRATCHPAD_B)
	breq FUNCTION_READ_SCRATCHPAD_B_RUN
	ret
; ------------------------------------------------------------------------------
FUNCTION_READ_SCRATCHPAD_B_RUN:
	; Z-ZEIGER			
	ldi ZL, LOW(adr_OW_SCRATCHPAD_B_BEREICH+0)
	ldi ZH,HIGH(adr_OW_SCRATCHPAD_B_BEREICH+0)
	; BIT-Zhler		
	LDS temp,(adr_OW_BIT_ZAEHLER)
	; BIT auslesen		
	rcall FUNKTION_SRAM_BIT_READ_Z_TEMP			; inp: temp+Z OUT: temp+Carry	
	; AUSWERTUNG		
	BRCS FUNCTION_READ_SCRATCHPAD_B_WRITE_1SLOT	; CARRY=1 ==> SPRUNG			
; ------------------------------------------------------------------------------
FUNCTION_READ_SCRATCHPAD_B_WRITE_0SLOT:
	rcall STATUS_TX_0SLOT_SETZEN ; STATUS: TX-0SLOT	
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
FUNCTION_READ_SCRATCHPAD_B_WRITE_1SLOT:
	rcall STATUS_TX_1SLOT_SETZEN ; STATUS: TX-0SLOT	
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_READ_SCRATCHPAD_C:
	; SCRATCHPAD READ ?	
	LDS temp,(adr_OW_RX_FUNCTION_COMMAND)	
	cpi temp,(OW_FUNCTION_READ_SCRATCHPAD_C)
	breq FUNCTION_READ_SCRATCHPAD_C_RUN
	ret
; ------------------------------------------------------------------------------
FUNCTION_READ_SCRATCHPAD_C_RUN:
	; Z-ZEIGER			
	ldi ZL, LOW(adr_OW_SCRATCHPAD_C_BEREICH+0)
	ldi ZH,HIGH(adr_OW_SCRATCHPAD_C_BEREICH+0)
	; BIT-Zhler		
	LDS temp,(adr_OW_BIT_ZAEHLER)
	; BIT auslesen		
	rcall FUNKTION_SRAM_BIT_READ_Z_TEMP			; inp: temp+Z OUT: temp+Carry	
	; AUSWERTUNG		
	BRCS FUNCTION_READ_SCRATCHPAD_C_WRITE_1SLOT	; CARRY=1 ==> SPRUNG			
; ------------------------------------------------------------------------------
FUNCTION_READ_SCRATCHPAD_C_WRITE_0SLOT:
	rcall STATUS_TX_0SLOT_SETZEN ; STATUS: TX-0SLOT	
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
FUNCTION_READ_SCRATCHPAD_C_WRITE_1SLOT:
	rcall STATUS_TX_1SLOT_SETZEN ; STATUS: TX-0SLOT	
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_WRITE_SCRATCHPAD_A:
	; SCRATCHPAD WRITE ?	
	LDS temp,(adr_OW_RX_FUNCTION_COMMAND)	
	cpi temp,(OW_FUNCTION_WRITE_SCRATCHPAD_A)
	breq FUNCTION_WRITE_SCRATCHPAD_A_RUN
	ret
; ------------------------------------------------------------------------------
FUNCTION_WRITE_SCRATCHPAD_A_RUN:
	; Z-ZEIGER		
	ldi ZL, LOW(adr_OW_SCRATCHPAD_A_BEREICH+0)
	ldi ZH,HIGH(adr_OW_SCRATCHPAD_A_BEREICH+0)
	; STATUS laden und abfragen
	rcall STATUS_ABFRAGE_UMWANDLUNG_OUT_TEMP ; OUT: 0=0SLOT 1=1SLOT	
	tst temp
	brne FUNCTION_WRITE_SCRATCHPAD_A_RX_1SLOT
FUNCTION_WRITE_SCRATCHPAD_A_RX_0SLOT:
	; BIT-ZHLER	
	LDS temp,(adr_OW_BIT_ZAEHLER)
	CLC 									; Clear Carry	
	rcall FUNKTION_SRAM_BIT_WRITE_Z_TEMP	; inp: C+temp+Z 
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
FUNCTION_WRITE_SCRATCHPAD_A_RX_1SLOT:
	; BIT-ZHLER	
	LDS temp,(adr_OW_BIT_ZAEHLER)
	SEC 									; set Carry		
	rcall FUNKTION_SRAM_BIT_WRITE_Z_TEMP	; inp: C+temp+Z 
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_WRITE_SCRATCHPAD_B:
	; SCRATCHPAD WRITE ?	
	LDS temp,(adr_OW_RX_FUNCTION_COMMAND)	
	cpi temp,(OW_FUNCTION_WRITE_SCRATCHPAD_B)
	breq FUNCTION_WRITE_SCRATCHPAD_B_RUN
	ret
; ------------------------------------------------------------------------------
FUNCTION_WRITE_SCRATCHPAD_B_RUN:
	; Z-ZEIGER		
	ldi ZL, LOW(adr_OW_SCRATCHPAD_B_BEREICH+0)
	ldi ZH,HIGH(adr_OW_SCRATCHPAD_B_BEREICH+0)
	; STATUS laden und abfragen
	rcall STATUS_ABFRAGE_UMWANDLUNG_OUT_TEMP ; OUT: 0=0SLOT 1=1SLOT	
	tst temp
	brne FUNCTION_WRITE_SCRATCHPAD_B_RX_1SLOT
FUNCTION_WRITE_SCRATCHPAD_B_RX_0SLOT:
	; BIT-ZHLER	
	LDS temp,(adr_OW_BIT_ZAEHLER)
	CLC 									; Clear Carry	
	rcall FUNKTION_SRAM_BIT_WRITE_Z_TEMP	; inp: C+temp+Z 
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
FUNCTION_WRITE_SCRATCHPAD_B_RX_1SLOT:
	; BIT-ZHLER	
	LDS temp,(adr_OW_BIT_ZAEHLER)
	SEC 									; set Carry		
	rcall FUNKTION_SRAM_BIT_WRITE_Z_TEMP	; inp: C+temp+Z 
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNCTION_WRITE_SCRATCHPAD_C:
	; SCRATCHPAD WRITE ?	
	LDS temp,(adr_OW_RX_FUNCTION_COMMAND)	
	cpi temp,(OW_FUNCTION_WRITE_SCRATCHPAD_C)
	breq FUNCTION_WRITE_SCRATCHPAD_C_RUN
	ret
; ------------------------------------------------------------------------------
FUNCTION_WRITE_SCRATCHPAD_C_RUN:
	; Z-ZEIGER		
	ldi ZL, LOW(adr_OW_SCRATCHPAD_C_BEREICH+0)
	ldi ZH,HIGH(adr_OW_SCRATCHPAD_C_BEREICH+0)
	; STATUS laden und abfragen
	rcall STATUS_ABFRAGE_UMWANDLUNG_OUT_TEMP ; OUT: 0=0SLOT 1=1SLOT	
	tst temp
	brne FUNCTION_WRITE_SCRATCHPAD_C_RX_1SLOT
FUNCTION_WRITE_SCRATCHPAD_C_RX_0SLOT:
	; BIT-ZHLER	
	LDS temp,(adr_OW_BIT_ZAEHLER)
	CLC 									; Clear Carry	
	rcall FUNKTION_SRAM_BIT_WRITE_Z_TEMP	; inp: C+temp+Z 
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
FUNCTION_WRITE_SCRATCHPAD_C_RX_1SLOT:
	; BIT-ZHLER	
	LDS temp,(adr_OW_BIT_ZAEHLER)
	SEC 									; set Carry		
	rcall FUNKTION_SRAM_BIT_WRITE_Z_TEMP	; inp: C+temp+Z 
	rjmp FUNKTION_BIT_ZAEHLER_PLUS_EINS
; ##############################################################################
; ##############################################################################
; ##############################################################################
