; ##############################################################################
; ##############################################################################
; ##############################################################################
WDR_INITIALISIERUNG:
; Watchdog aktivieren (max. Zeit)					
	ldi TEMP,(1<<WDCE)|(1<<WDE)  
	out wdtcr,TEMP       
	ldi TEMP,(1<<WDE) | (1<<WDP2)|(1<<WDP1)|(1<<WDP0) 
	out wdtcr,temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
NEUSTART_MIT_WDR:
	WDR
	in temp, MCUCSR
	andi temp,0b00001000
	tst temp
	breq NEUSTART_MIT_WDR_FEHLER
	; MCUCSR clear		
	out MCUCSR,NULL
	ret
NEUSTART_MIT_WDR_FEHLER:
	rjmp NEUSTART_MIT_WDR_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
SRAM_CLEAR:
	ldi ZL, LOW (adr_DATEN)
	ldi ZH, HIGH(adr_DATEN)
	ldi temp,0
SRAM_CLEAR_w:
	ST z+,temp
	cpi ZH, HIGH(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	cpi ZL, LOW(RAMEND-1)	; Vergleich?		
	brlo SRAM_CLEAR_w		; kleiner => SPRUNG	
	breq SRAM_CLEAR_w		; gleich  => SPRUNG	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
PROGRAMM_CHECK:
	; NULL		
	tst NULL
	brne PROGRAMM_CHECK_FEHLER
	; EINS		
	mov temp,EINS
	cpi temp,1
	brne PROGRAMM_CHECK_FEHLER
	; VOLL		
	mov temp,VOLL
	cpi temp,255
	brne PROGRAMM_CHECK_FEHLER
	; SRAM CHECK
	LDS temp,(adr_SRAM_CHECK)
	cpi temp,'S'
	brne PROGRAMM_CHECK_FEHLER
	ret
;-------------------------------------------------------------------------------
; SCHLEIFE																		
PROGRAMM_CHECK_FEHLER:
	rjmp PROGRAMM_CHECK_FEHLER
; ##############################################################################
; ##############################################################################
; ##############################################################################
; erster auftretender FEHLER wird gespeichert									
; INP: temp(CODE) temp1(WERT)													
; OUT: LED(ROT), SRAM (adr_ERROR_CODE)(adr_ERROR_WERT)							
;																				
;BEISPIEL:																		
;	; ERROR																		
;	ldi temp,(ERROR_)	; CODE													
; 	ldi temp1,2 																
;	rcall ERROR_SPEICHERN 														
;																				
ERROR_SPEICHERN:
	cbi PORTD,LED_OW_ROT		; ROT				
	push temp					; sichern			
	LDS temp,(adr_OW_ERROR_CODE)
	tst temp
	breq ERROR_SPEICHERN_RUN
	pop temp					; wiederherstellen	
	ret
;-------------------------------------------------------------------------------
ERROR_SPEICHERN_RUN:
	pop temp					; wiederherstellen	
	; ERROR CODE	
	STS(adr_OW_ERROR_CODE),temp	; speichern			
	STS(adr_OW_ERROR_WERT),temp1; speichern			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; ##############################################################################
; einzelnes BIT aus SRAM auslesen												
;																				
; INP: temp (Bitnummer 0...255)													
;	   ZL/ZH (SRAM-START-Adresse)												
; OUT: temp + CARRY																
;																				
; rcall FUNKTION_SRAM_BIT_READ_Z_TEMP	; inp: temp+Z OUT: temp+Carry			
;																				
FUNKTION_SRAM_BIT_READ_Z_TEMP:
	push temp1			; sichern	
	; BYTE aufbereiten	
	mov temp1,temp		; KOPIE		
	LSR temp1			; 3xrechts	
	LSR temp1
	LSR temp1
	; Z addieren	
	add ZL,temp1
	adc ZH,NULL
	; BYTE laden	
	LD temp1,Z
; ------------------------------------------------------------------------------
	; Z-INITIALISIEREN	
	ldi ZL,LOW (FUNKTION_SRAM_READ_BIT_Z_TEMP_SPRUNGMARKE)
	ldi ZH,HIGH(FUNKTION_SRAM_READ_BIT_Z_TEMP_SPRUNGMARKE)
	; BITS aufbereiten + addieren	
	andi temp, 0b00000111
	add ZL,temp
	adc ZH,NULL
	; Sprung nach Z	
	IJMP
FUNKTION_SRAM_READ_BIT_Z_TEMP_SPRUNGMARKE:
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_B0
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_B1
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_B2
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_B3
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_B4
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_B5
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_B6
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_B7
; ------------------------------------------------------------------------------
FUNKTION_SRAM_BIT_READ_Z_TEMP_B0:
	SBRS temp1,0						; springe, wenn Bit set	
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_0
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_1
FUNKTION_SRAM_BIT_READ_Z_TEMP_B1:
	SBRS temp1,1						; springe, wenn Bit set	
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_0
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_1
FUNKTION_SRAM_BIT_READ_Z_TEMP_B2:
	SBRS temp1,2						; springe, wenn Bit set	
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_0
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_1
FUNKTION_SRAM_BIT_READ_Z_TEMP_B3:
	SBRS temp1,3						; springe, wenn Bit set	
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_0
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_1
FUNKTION_SRAM_BIT_READ_Z_TEMP_B4:
	SBRS temp1,4						; springe, wenn Bit set	
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_0
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_1
FUNKTION_SRAM_BIT_READ_Z_TEMP_B5:
	SBRS temp1,5						; springe, wenn Bit set	
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_0
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_1
FUNKTION_SRAM_BIT_READ_Z_TEMP_B6:
	SBRS temp1,6						; springe, wenn Bit set	
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_0
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_1
FUNKTION_SRAM_BIT_READ_Z_TEMP_B7:
	SBRS temp1,7						; springe, wenn Bit set	
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_0
	rjmp FUNKTION_SRAM_BIT_READ_Z_TEMP_1
; ------------------------------------------------------------------------------
FUNKTION_SRAM_BIT_READ_Z_TEMP_0:
	pop temp1						; wiederherstellen	
	clr temp						; OUT				
	CLC								; Carry clear		
	ret
FUNKTION_SRAM_BIT_READ_Z_TEMP_1:
	pop temp1						; wiederherstellen	
	ldi temp,1						; OUT				
	SEC								; CARRY set			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; einzelnes BIT aus SRAM auslesen												
;																				
; INP:	CARRY																	
;		temp (Bitnummer 0...255)												
;	   	ZL/ZH (SRAM-START-Adresse)												
;																				
; rcall FUNKTION_SRAM_BIT_WRITE_Z_TEMP	; inp: C+temp+Z 						
;																				
FUNKTION_SRAM_BIT_WRITE_Z_TEMP:
	push temp1			; sichern	
	; Carry=0 ?		
	BRCC FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0
	rjmp FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1
; ------------------------------------------------------------------------------
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0:
	; BYTE aufbereiten	
	mov temp1,temp		; KOPIE		
	LSR temp1			; 3xrechts	
	LSR temp1
	LSR temp1
	; Z addieren		
	add ZL,temp1
	adc ZH,NULL
	; BYTE laden		
	LD temp1,Z
	; BITS aufbereiten	
	andi temp, 0b00000111
	cpi temp,0
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B0
	cpi temp,1
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B1
	cpi temp,2
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B2
	cpi temp,3
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B3
	cpi temp,4
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B4
	cpi temp,5
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B5
	cpi temp,6
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B6
	rjmp FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B7
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B0:
	andi temp1,0b11111110
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B1:
	andi temp1,0b11111101
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B2:
	andi temp1,0b11111011
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B3:
	andi temp1,0b11110111
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B4:
	andi temp1,0b11101111
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B5:
	andi temp1,0b11011111
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B6:
	andi temp1,0b10111111
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_0_B7:
	andi temp1,0b01111111
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
; ------------------------------------------------------------------------------
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1:
	; BYTE aufbereiten	
	mov temp1,temp		; KOPIE		
	LSR temp1			; 3xrechts	
	LSR temp1
	LSR temp1
	; Z addieren		
	add ZL,temp1
	adc ZH,NULL
	; BYTE laden		
	LD temp1,Z
	; BITS aufbereiten	
	andi temp, 0b00000111
	cpi temp,0
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B0
	cpi temp,1
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B1
	cpi temp,2
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B2
	cpi temp,3
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B3
	cpi temp,4
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B4
	cpi temp,5
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B5
	cpi temp,6
	breq FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B6
	rjmp FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B7
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B0:
	ori temp1,0b00000001
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B1:
	ori temp1,0b00000010
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B2:
	ori temp1,0b00000100
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B3:
	ori temp1,0b00001000
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B4:
	ori temp1,0b00010000
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B5:
	ori temp1,0b00100000
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B6:
	ori temp1,0b01000000
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
	ret
FUNKTION_SRAM_BIT_WRITE_Z_TEMP_1_B7:
	ori temp1,0b10000000
	ST Z,temp1		; BYTE speichern	
	pop temp1		; wiederherstellen	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
FUNKTION_BIT_ZAEHLER_PLUS_EINS:
	push temp			; sichern			
	; BIT-ZHLER	
	LDS temp,(adr_OW_BIT_ZAEHLER); laden	
	; +1			
	inc temp
	; berlauf ?	
	tst temp
	breq FUNKTION_BIT_ZAEHLER_PLUS_EINS_FERTIG
	STS(adr_OW_BIT_ZAEHLER),temp; speichern	
FUNKTION_BIT_ZAEHLER_PLUS_EINS_FERTIG:
	pop temp			; wiederherstellen	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################



